%{

#define YYSTYPE char*
#include "config.tab.h"
extern int line_no;

char *stroptdup(char *optstr);

%}

INT	(0x)?[0-9]+
STRING	\"[^"]*\"

%%

{INT}		{ yylval = strdup(yytext); return INT; }
{STRING}	{ yylval = stroptdup(yytext); return STRING; }
[ \t]
\n		{ line_no++; }

pll		{ return pll; }
board		{ return board; }
cmd		{ return cmd; }
mode		{ return mode; }
default		{ return default_; }
fsb		{ return fsb; }
mem		{ return mem; }
pci		{ return pci; }
agp		{ return agp; }
feature		{ return feature; }

.		{ return yytext[0]; }

%%

char *stroptdup(char *optstr) {
	int len = strlen(optstr);
	char *target = malloc(len-1);
	memcpy(target, &optstr[1], len-2);
	target[len-1] = '\0';
	return target;
}
